/*
 * ValidarDiscapacidad.java
 *
 * Created on 4 de abril de 2007, 11:47 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.fidufosyga.rules;

import java.text.SimpleDateFormat;
import java.util.Date;

import com.fidufosyga.rules.util.ObtenerDiasEntreFechas;
import com.fidufosyga.rules.util.ValidarFecha;

/**
 * 
 * @author Jsolano
 */
public class ValidarDiscapacidad extends AbstractRule {

	String DATE_FORMAT = "dd/MM/yyyy";

	SimpleDateFormat sdf;

	/** Creates a new instance of CampoLlenoParaUnValorDiferenteDeOtroCampo */

	public ValidarDiscapacidad() {
		sdf = new SimpleDateFormat(DATE_FORMAT);
		sdf.setLenient(false);
	}

	// 9,'B',12,'2',13
	// 19,B,23,13,24
	// 20,B,23,14,24
	public boolean performValidation(String field, String registro[],
			String nombreArchivo) {
		String fechaNacimiento = registro[new Integer((String) getParams()[0])
				.intValue()];
		String fechaFormulario = registro[new Integer((String) getParams()[5])
				.intValue()];
		String columnaTipoAfiliado = registro[new Integer(
				(String) getParams()[2]).intValue()];
		String columnaParentesco = registro[new Integer((String) getParams()[4])
				.intValue()];
		String tipoAfiliado = (String) getParams()[1];
		String parentesco = (String) getParams()[3];

		if (!ValidarFecha.esFecha(fechaNacimiento))
			return false;

		Date dtFechaNacimiento;

		try {
			dtFechaNacimiento = sdf.parse(fechaNacimiento);
		} catch (Exception e) {
			return false;
		}

		if (!ValidarFecha.esFecha(fechaFormulario))
			return false;

		Date dtFechaFormulario;

		try {
			dtFechaFormulario = sdf.parse(fechaFormulario);
		} catch (Exception e) {
			return false;
		}

		// long edadDias = ObtenerDiasEntreFechas.calcular(dtFechaNacimiento,
		// Calendar.getInstance().getTime());
		long edadDias = ObtenerDiasEntreFechas.calcular(dtFechaNacimiento,
				dtFechaFormulario);
		;
		long annos = (long) Math.floor(edadDias / 365.25);

		if (columnaTipoAfiliado.equals(tipoAfiliado)
				&& (parentesco.equals(columnaParentesco)|| columnaParentesco.equals ("4") || columnaParentesco.equals ("9"))) {//|| columnaParentesco.equals ("5") se suprime por Res.762 MQA
			//if (annos >= 18 && annos <= 25 && field.equals("E"))
			//	return false;
                     //    System.out.println ("Esta es la edad");
                     //    System.out.println (annos);
			if (annos >= 25 && field.equals("D"))
				return false;

			if (annos < 25 && (field.length() == 0 || field.equals("D") || field.equals("E") ))
				return false;
			return true;
		}

		if (field.length() > 0)
			return true;

		return false;

	}

}
